<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux

//$ESIA_WIDGET_NOTREE=TRUE;
$webp_name='inventory';
//$webp_model='model_'.$webp_name.'.php';

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
//Inclusion des librairie
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 */

include_once $path.'/Model_adm.php';
include_once 'inventory.conf.php';
include_once MODEL_INVENTORY;


$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_INVENTORY');
$plugin_url = $arr[0]['apache_path'];
$smarty->assign('plugin_url',$plugin_url);
$page_url = "$plugin_url".$arr[0]['index_page'];
$template_path= $path.$plugin_url.'templates/';
$smarty->assign('lang',  $lang);
//valeur par défaut

if(!empty($_GET['action']))
{
    $action = $_GET['action'];
}
session_write_close();

$errors = array();
try
{
    $groupId = 0;
    if(!empty($_REQUEST['group']) && is_numeric($_REQUEST['group']))
    {
        $groupId = intval($_REQUEST['group']);
    }
    $smarty->assign('groupId', $groupId);

    if($action == "add" || $action == "update")
    {
        if(isset($_POST['rule_id']) && !empty($_POST['name']))
        {
            $ruleArray = array();
            $ruleArray['name'] = $_POST['name'];
            $ruleArray['component_id'] = $_POST['component'];
            $ruleArray['target_version'] = $_POST['version_target'];
            $ruleArray['operator_target'] = $_POST['operator'];
            $ruleArray['match'] = NULL;
            $ruleArray['description'] = $_POST['description'];
            $ruleArray['activate'] = $_POST['active'];

            $ruleArray['target'] = array(
                'groups' => array(),
                'devices' => array(),
            );
            if(isset($_POST['targetDevice']) && is_array($_POST['targetDevice']))
            {
                $ruleArray['target']['devices'] = $_POST['targetDevice'];
            }
            if(isset($_POST['targetGroup']) && is_array($_POST['targetGroup']))
            {
                $ruleArray['target']['groups'] = $_POST['targetGroup'];
            }

            if($action == "add")
            {
                $newId = Model_inventory::addRules($dbconnection, $ruleArray);
                $smarty->assign('success', $lang['INVENTORY_RULE_ADD_SUCCESS']);

                // When add action is over set it to update to display update page
                $action = "update";
                $_REQUEST['rule'] = $newId;
            }
            elseif($action == "update")
            {
                Model_inventory::updateRule($dbconnection, $_POST['rule_id'], $ruleArray);
                $smarty->assign('success', $lang['INVENTORY_RULE_UPDT_SUCCESS']);
                $_REQUEST['rule'] = $_POST['rule_id'];
            }
        }
        // Data for view
        // Get components list
        $componentsList = Model_inventory::getGroupedComponents($dbconnection);
        $smarty->assign('componentsList', $componentsList);

        $devices = Model_esia::getNodeList($dbconnection, $user->getId());
        $groups = Model_inventory::getAvaillableNodeGroupsByUser($dbconnection, $user->getId());

        $smarty->assign('devices', $devices);
        $smarty->assign('groups', $groups);
        $smarty->assign('INV_RULES_OPERATORS', INV_RULES_OPERATORS);

        $ruleId = 0; // No rule id for add action
        $rule = array();
        if($action == "update")
        {
            if(empty($_REQUEST['rule']))
            {
                throw new Exception($lang['INVENTORY_ERROR_RULE_ID']);
            }
            // Get current rule informations
            $ruleId = intval($_REQUEST['rule']);
            $rule = Model_inventory::getListRules($dbconnection, $ruleId);
            $rule = $rule[$ruleId];
        }

        $smarty->assign('ruleId', $ruleId);
        $smarty->assign('rule', $rule);
    }
    elseif($action == "detail")
    {
        $tab = '';
        if(!empty($_GET['tab']))
        {
            $tab = $_GET['tab'];
        }

        if($tab == 'conf')
        {
            $rule = Model_inventory::getListRules($dbconnection, $_GET['ruleId']);
            $rule = $rule[$_GET['ruleId']];
            $smarty->assign('rule', $rule);
            $targetList = array();
            if(isset($rule['target']['groups']))
            {
                foreach($rule['target']['groups'] as $groupId)
                {
                    $group = Model_inventory::getGroup($dbconnection, $groupId);
                    $targetList[] = array('type' => 'group', 'name' => $group[$groupId]['name']);
                }
            }
            if(isset($rule['target']['devices']))
            {
                foreach($rule['target']['devices'] as $deviceId)
                {
                    $device = Model_inventory::getAllDevice($dbconnection, $deviceId);
                    $targetList[] = array('type' => 'device', 'name' => $device[$deviceId]['name']);
                }
            }
            $smarty->assign('targetList', $targetList);
        }
        elseif($tab == 'components')
        {
            // Get rule results informations
            $componentsList = Model_inventory::getScannedRuleReport($dbconnection, $_GET['ruleId']);
            $smarty->assign('componentsList', $componentsList);
        }

        $smarty->assign('tab', $tab);
        $smarty->assign('ruleId', $_GET['rule']);
    }
    elseif($action == "delete" )
    {
        if(is_numeric($_GET['rule']))
        {
            $idRule = $_GET['rule'];
            $smarty->assign('idRule', $idRule);
            if(isset($_POST['deleteConfirmed']) && $_POST['deleteConfirmed'] == $idRule)
            {
                Model_inventory::deleteRule($dbconnection,$idRule);
                $smarty->assign('success', $lang['INVENTORY_DELETE_SUCCESS']);
            }
        }
    }
    else
    {
        echo "Action not found\n";
    }
}
catch(EsiaDbException | Exception $e)
{
	$errors[] = $e->getMessage();
}
$smarty->assign('errors', $errors);
$smarty->assign('action', $action);

$smarty->display($template_path.'dialog_inventory.html');
?>
