<?php
/*
** @name display_inventory.php
**
** @description: controller for inventory ajax requests
** @author: Quentin George <q.george@esia-sa.com>
** @date: 14/03/2023
*/
$path = $_SERVER['DOCUMENT_ROOT'];

//Inclusion des librairie
include_once $path . '/common.php';
include_once 'inventory.conf.php';
include_once MODEL_INVENTORY;
include_once LIB_INVENTORY;


if(isset($_GET['action']))
{
	$action = $_GET['action'];
}
elseif(isset($_POST['action']))
{
	$action = $_POST['action'];
}

try
{
	if($action == "updateScanRulesConfig")
	{
		if(empty($_POST['rulesNextExecDate']) || empty($_POST['rulesNextExecTime']))
		{
			throw new Exception($lang['INVENTORY_ERROR_DATE_PARAM']);
		}
		if(!isset($_POST['scanRulesInterval']) || !in_array($_POST['scanRulesInterval'], INV_SCAN_VALID_INTERVALS))
		{
			throw new Exception($lang['INVENTORY_ERROR_INTERVAL_PARAM']);
		}
		
		// Check if destination files dir is present or create it
		//checkInvDataDir($path, $lang['INVENTORY_ERROR_CREATE_DIR']);

		// Format data
		$nextDate = new DateTime($_POST['rulesNextExecDate'] . $_POST['rulesNextExecTime']);
		
		$data = array(
			'next_exec' => $nextDate->getTimestamp(),
			'interval' => $_POST['scanRulesInterval'],
			'type_node' => 'rule',
		);
		
		// Write data into file
		//setInvDataJsonFile($path, INV_RULES_CONF_FILE, $data, array($lang['INVENTORY_ERROR_OPEN_FILE'], $lang['INVENTORY_ERROR_WRITE_FILE']));
		
		$ret = Model_inventory::addScan($dbconnection,$data);
		// If everything was ok send success message
		echo json_encode($lang['INVENTORY_SCAN_RULES_PARAM_SUCCESS']);
	}
	elseif($action == "execScanRulesNow")
	{
		// Check if destination files dir is present or create it
		//checkInvDataDir($path, $lang['INVENTORY_ERROR_CREATE_DIR']);
		// Get previously saved config in /data directory
		//$execNowConf = getInvDataJsonFile($path, INV_EXEC_NOW_CONF_FILE, $lang['INVENTORY_ERROR_OPEN_FILE']);
		//$execNowConf['scan_rules'] = TRUE;
		
		// Write data into file
		//setInvDataJsonFile($path, INV_EXEC_NOW_CONF_FILE, $execNowConf, array($lang['INVENTORY_ERROR_OPEN_FILE'], $lang['INVENTORY_ERROR_WRITE_FILE']));
		
		$data = array(
			'next_exec' => time(),	
			'type_node' => 'rule',
		);
		$ret = Model_inventory::addScan($dbconnection, $data);
		// If everything was ok send success message
		echo json_encode($lang['INVENTORY_SCAN_RULES_NOW_SUCCESS']);
	}
	elseif($action == "addScanImport")
	{
		if(empty($_POST['scanImportGroup']))
		{
			throw new Exception($lang['INVENTORY_ERROR_GROUP_PARAM']);
		}
		if(empty($_POST['importNextExecDate']) || empty($_POST['importNextExecTime']))
		{
			throw new Exception($lang['INVENTORY_ERROR_DATE_PARAM']);
		}
		if(!isset($_POST['scanImportInterval']))
		{
			throw new Exception($lang['INVENTORY_ERROR_INTERVAL_PARAM']);
		}
		if(!isset($_POST['scanImportType']))
		{
			throw new Exception($lang['INVENTORY_ERROR_TYPE_PARAM']);
		}

		// Format data
		$nextDate = new DateTime($_POST['importNextExecDate'] . $_POST['importNextExecTime']);
		
		$data = array(
			'next_exec' => $nextDate->getTimestamp(),
			'interval' => $_POST['scanImportInterval'],
			'target' => array('g' => $_POST['scanImportGroup']),
			'type' => $_POST['scanImportType'],
		);
		$ret = Model_inventory::addScan($dbconnection, $data);

		// If everything was ok send success message
		echo json_encode($lang['INVENTORY_SCAN_IMPORT_PARAM_SUCCESS']);
	}
	elseif($action == "execScanImportNow")
	{
		
		if(empty($_POST['scanImportGroup']))
		{
			throw new Exception($lang['INVENTORY_ERROR_GROUP_PARAM']);
		}
		if(!isset($_POST['scanImportType']))
		{
			throw new Exception($lang['INVENTORY_ERROR_TYPE_PARAM']);
		}
		
		// Format data
		$data = array(
			'next_exec' => time(),
			'target' => array('g' => $_POST['scanImportGroup']),
			'type' => $_POST['scanImportType'],
		);
		
		$ret = Model_inventory::addScan($dbconnection, $data);
		
		// If everything was ok send success message
		echo json_encode($lang['INVENTORY_SCAN_IMPORT_NOW_SUCCESS']);
	}
}
catch(EsiaDbException | Exception $e)
{
	echo json_encode(array('errors' => $e->getMessage()));
}

exit(0);

?>
